/* 2 September 2001, Alexandros Droseltis */

#include<stdio.h>
#include"transposer.h"
#include"filters.h"
#include"translators.h"
#include"printers.h"

void enharmonic(int acc1, int note1, int *acc2, int *note2);
void make_name(int argc, char **argv, char infilename[]);
void take(char inname[], char melody[][2], char title[], int *menge);
void mel_char2num(int plithos, char melody[][2], int mel_num[][2]);
int CheckForClass(char class);
void mel_num2char(int plithos, int input[][2], char output[][2]);
int chromatic(int x, int y);
void make_matrix(int head, int row_num[][2], int output[][12][2], int quant[], char qual[], int plithos);
void intervals(int quant[], char qual[]);
void translate(int plithos, int input[][12][2], char output[][12][2]);
void recognize(int acc1, int note1, int acc2, int note2, int *interval, char *class, int *ufo);
int chromatic2(int x, int y);
void list_intervals(int input[][2], int quant[], char qual[], int plithos);
void make_Io(int row_num[][2], int interval[], char type[], int trans2[][2], int plithos);
void retro(int plithos, char input[][12][2], char output[][12][2]);
void make_options(char **argv, int i, int opt[]);
void init_opt(int opt[]);

void main(int argc, char **argv)
{
  char c2, melody[12][2], trans1_char[12][2], qual[12], Prime_char[12][12][2], Inver_char[12][12][2], type[100], Retrograde_c[12][12][2], RInversion_c[12][12][2], title[40], infilename[20];
  int i, j, t, mel_num[12][2], trans1[12][2], h, Prime[12][12][2], quant[12], interval[100], row_inv_num[12][2], Inversion[12][12][2], opt[12], plithos;


  init_opt(opt);

  if(argc>2)
    {
      for(i=1; i<argc; i++) make_options(argv, i, opt);
    }
  if(argc==1) printf("You must enter an input file.\n");
  if(argc!=1)
    {
  make_name(argc, argv, infilename);
  copyright(infilename);
  /* Input the melody */
  take(argv[argc-1], melody, title, &plithos);
  /* Change the melody into numbers */
  mel_char2num(plithos, melody, mel_num);
  /* Read the head tone of the row */
  h=chromatic(mel_num[0][0], mel_num[0][1]);
  //printf("head=%d\n", h);
  /* The intervals according to them them the transposition of the one row
     will take place. */
  intervals(quant, qual);
  /* Generate the matrix for the P-transpositions. */
  make_matrix(h, mel_num, Prime, quant, qual, plithos);


  /***** GENERATION OF THE I-MATRIX *****/
  /* Recognize the intervals of the Prime form. */
  list_intervals(mel_num, interval, type, plithos);
  /* Generate the I(head) form. */
  make_Io(mel_num, interval, type, row_inv_num, plithos);
  /* Generate the matrix for the I-transpositions. */
  make_matrix(h, row_inv_num, Inversion, quant, qual, plithos);

  /* The Prime and Inversion matrices are filtered. */  
  Filter(Prime, plithos, opt);
  Filter(Inversion, plithos, opt);

  /* The Prime- and the Inversion-matrix are translated from numbers into characters. */
  translate(plithos, Prime, Prime_char);
  translate(plithos, Inversion, Inver_char);

  /* The retrograde forms are generated (R and RI). */
  retro(plithos, Prime_char, Retrograde_c);
  retro(plithos, Inver_char, RInversion_c);

  /* The .tex file is being cleared to accept the new data. */
  clear_file(infilename);
  /* The title and the P, RI, I and RI matrices are printed. */
  print_score(plithos, infilename, Prime_char, Retrograde_c, Inver_char, RInversion_c, title, opt);
  }  
}

void make_Io(int row_num[][2], int interval[], char type[], int trans2[][2], int plithos)
{
  int i, t, temp[12][2], trans[12][2];
  char c2;
  /*
  printf("The intervals are: ");
  for(i=0; i<plithos; i++)
    {
      printf("%d%c ", interval[i], type[i]);
    }
  printf("\n\n");
  */

  for(i=0; i<plithos; i++)
    {
      temp[i][0]=row_num[0][0];
      temp[i][1]=row_num[0][1];
    }

  for(i=0; i<plithos; i++)
    {
      t=0-interval[i]; c2=type[i];
      transposer(temp, i, t, c2, trans2);
    }
      printf("\n");

      /* Check results */
      /*
	printf("\n");
	printf("The original row is: ");
	for(i=0; i<plithos; i++) printf("%d_%d ", row_num[i][0], row_num[i][1]);
	printf("\n");
	printf("The inverted row is: ");
	for(i=0; i<plithos; i++) printf("%2d_%2d ", trans2[i][0], trans2[i][1]);
	printf("\n");  
      */
}

void list_intervals(int input[][2], int quant[], char qual[], int plithos)
{
  int i, q, ufo, acc2, note2;
  char m;

  for(i=0; i<plithos; i++)
    {
      ufo=0;
      recognize(input[0][0], input[0][1], input[i][0], input[i][1], &q, &m, &ufo);
      if(ufo==1)
	{
	  enharmonic(input[i][0], input[i][1], &acc2, &note2);
	  input[i][0]=acc2; input[i][1]=note2;
	  i--;
	}
      else
	{
	  quant[i]=q;
	  qual[i]=m;
	}
    }
  /* Check results */
  /*
  printf("\n");
  printf("The intervals are: ");
  for(i=0; i<plithos-1; i++)
    {
      printf("%d%c ", quant[i], qual[i]);
    }
  printf("\n\n");
  */
}

void recognize(int acc1, int note1, int acc2, int note2, int *interval, char *class, int *ufo)
{
  int i, diff;

  *ufo=0;
  if(chromatic2(acc2, note2)>=chromatic2(acc1, note1)) *interval=note2-note1+1;
  else *interval=note2-note1-1;
  diff=abs(chromatic2(acc1, note1)-chromatic2(acc2, note2));
  //printf("diff=%d Interval=%d", diff, *interval);
  if((abs(*interval)%7==2 && diff%12==0) ||
     (abs(*interval)%7==3 && diff%12==2) ||
     (abs(*interval)%7==4 && diff%12==4) ||
     (abs(*interval)%7==5 && diff%12==6) ||
     (abs(*interval)%7==6 && diff%12==7) ||
     (abs(*interval)%7==0 && diff%12==9) ||
     (abs(*interval)%7==1 && diff%12==11))
    *class='d';
  else if((abs(*interval)%7==2 && diff%12==1) ||
	  (abs(*interval)%7==3 && diff%12==3) ||
	  (abs(*interval)%7==6 && diff%12==8) ||
	  (abs(*interval)%7==0 && diff%12==10))
    *class='m';
  else if((abs(*interval)%7==2 && diff%12==2) ||
	  (abs(*interval)%7==3 && diff%12==4) ||
	  (abs(*interval)%7==6 && diff%12==9) ||
	  (abs(*interval)%7==0 && diff%12==11))
    *class='M';
  else if((abs(*interval)%7==4 && diff%12==5) ||
	  (abs(*interval)%7==5 && diff%12==7) ||
	  (abs(*interval)%7==1 && diff%12==0))
    *class='p';
  else if((abs(*interval)%7==2 && diff%12==3) ||
	  (abs(*interval)%7==3 && diff%12==5) ||
	  (abs(*interval)%7==4 && diff%12==6) ||
	  (abs(*interval)%7==5 && diff%12==8) ||
	  (abs(*interval)%7==6 && diff%12==10) ||
	  (abs(*interval)%7==0 && diff%12==0) ||
	  (abs(*interval)%7==1 && diff%12==1))
    *class='a';
  else
    {
      *interval=0;
      *class='x';
      *ufo=1;
    }
  //else printf("The class of the interval can not be indentified!\n");
}


/* The function "chromatic2" reads the two parameters of a numerical
   note (accidental, notename) and returns the chromatic2 number of it,
   e.g. ^f => 6, _a => 8.*/

int chromatic2(int x, int y)
{
  int erg, k;

  erg=y;
  k=0;
  while(erg>=7)
    {
      if(erg>=7)
	{
	  erg-=7;
	  k++;
	}
      else break;
      //printf("k=%d, erg=%d\n", k, erg);
    }

  if((y+7)%7<3) return (2*y-2*k+x);
  else return (2*y-2*k-1+x);
}


void make_matrix(int head, int row_num[][2], int output[][12][2], int quant[], char qual[], int plithos)
{
  int i, j, trans1[12][2], t;
  char c;

  /* 1st stadium of the transposition: from X(head) to X(11). */
  for(i=head; i<12; i++)
    {
      /* The arrays "quant" and "qual" get their start positions (quant[0] and qual[0],
	 s. function "intervals"). */
      t=quant[i-head]; c=qual[i-head];

      /* The transposition for every note of the given form begins. */
      for(j=0; j<plithos; j++)
	{
	  /* The transpodition happens as follows:
	     input         : row_num[][] (the given melodic line)
	     array position: j (that defines the note of the melodic line)
	     tone quantity : t (the quantity of the interval)
	     tone qualuty  : c (the quality of the interval)
	     output        : trans1[j][0], trans1[j][1] (the transposed note -accentental and note name). */
	  transposer(row_num, j, t, c, trans1);
	}
      /* The first part of the array that involves all the 12 transpositions of the 
	 given melodic line is being constructed. This part includes all transpositions
	 from "head" to 12. (e.g. if head=3, and the melodic line is a P(rime) form,
	 P(3), P(4), P(5), ..., P(12) are being constructed. */
      for(j=0; j<plithos; j++)
	{
	  output[i][j][0]=trans1[j][0];
	  output[i][j][1]=trans1[j][1];
	}
    }
  
  for(i=head-1; i>=0; i--)
    {
      t=0-quant[head-i]; c=qual[head-i];
      for(j=0; j<plithos; j++)
	{
	  transposer(row_num, j, t, c, trans1);
	}
      for(j=0; j<plithos; j++)
	{
	  output[i][j][0]=trans1[j][0];
	  output[i][j][1]=trans1[j][1];
	}
    }
  
  /* Print results for control */
  /*      
  printf("\n\t");
  for(i=0; i<12; i++)
    {
      printf("%d\t", i+1);
    }
      printf("\n\n");
  for(i=0; i<12; i++)
    {
      printf("%d:\t", i);
      for(j=0; j<plithos; j++)
	{
	  printf("%2d_%2d\t", output[i][j][0], output[i][j][1]);
	}
      printf(":%d", i);
      printf("\n");
    }
  */
}

void translate(int plithos, int input[][12][2], char output[][12][2])
{
  int i, j;

  for(i=0; i<12; i++)
    {
      for(j=0; j<plithos; j++)
	{
	  output[i][j][0]=num2accid(input[i][j][0]);
	  output[i][j][1]=num2notename(input[i][j][1]);
	}
    }
}

void intervals(int quant[], char qual[])
{
  quant[0]=1;
  qual[0]='p';

  quant[1]=2;
  qual[1]='m';
  
  quant[2]=2;
  qual[2]='M';
  
  quant[3]=3;
  qual[3]='m';
  
  quant[4]=3;
  qual[4]='M';
  
  quant[5]=4;
  qual[5]='p';
  
  quant[6]=4;
  qual[6]='a';
 
  quant[7]=5;
  qual[7]='p';
 
  quant[8]=6;
  qual[8]='m';
 
  quant[9]=6;
  qual[9]='M';
 
  quant[10]=7;
  qual[10]='m';
 
  quant[11]=7;
  qual[11]='M';
}

/* The functon "take" reads the row from the file "row.txt" and sends it
   to the 2D-table row[][2].
   The first dimension is the occasional note of the row (0, 1, 2 etc.)
   The second dimension is 2 digits:
   row[x][0]: the accidental (=, ^, _),
   row[x][1]: the name of the note (without the accidental).
*/

void take(char inname[], char melody[][2], char title[], int *menge)
{
  int i, d, occupied, j;
  char elem[100];
  FILE *outfile;
  outfile=fopen(inname, "r");

  /* experiment */
  fgets(elem, 100, outfile);

  occupied=(int)strlen(elem)-1;

  d=0;//There are 0 elements found.
  for(i=0; i<occupied; i++)
    {
      if(isgraph(elem[i])!=0)
	{
	  d++;//There is one more element.
	  j=0;
	  while(isgraph(elem[i])!=0)
	    {
	      melody[d-1][j]=elem[i];
	      i++;
	      j++;
	    }
	  melody[d-1][j]='\0';
	}
    }

  *menge=d;
  //printf("menge=%d\n", d);
  /*
    for(i=0; i<*menge; i++)
    {
    fscanf(outfile, "%s", melody[i]);
    }
  */
  //fgets(title, 40, outfile);
  fgets(title, 40, outfile);

  //fscanf(outfile, "%s", title);

  /* Print results for checking */
  /*
  printf("take-results:\n");
  for(i=0; i<menge; i++) printf("acc=%c, note=%c\n", melody[i][0], melody[i][1]);
  printf("\n");
  */
}


void mel_char2num(int plithos, char melody[][2], int mel_num[][2])
{
  int i;
  char a, b;

  for(i=0; i<plithos; i++)
    {
      a=melody[i][0];
      b=melody[i][1];

      mel_num[i][0]=accid2num(a);
      mel_num[i][1]=notename2num(b);
    }

  /* Print results for checking */
  /*
  printf("take-results:\n");
  for(i=0; i<plithos; i++) printf("acc=%d, note=%d\n", mel_num[i][0], mel_num[i][1]);
  printf("\n");
  */
}

/* The function "chromatic" reads the two parameters of a numerical
   note (accidental, notename) and returns the chromatic number of it,
   e.g. ^f => 6, _a => 8.*/

int chromatic(int x, int y)
{
  int i;
  i=(y+7)%7;

  if(i<3) return (2*i+x);
  else return (2*i-1+x);
}


void retro(int plithos, char input[][12][2], char output[][12][2])
{
  int i, j, r;

  for(i=0; i<12; i++)
    {
      for(j=0; j<plithos; j++)
	{
	  for(r=0; r<2; r++)
	    output[i][j][r]=input[i][plithos-j-1][r];
	}
    }
}

void mel_num2char(int plithos, int input[][2], char output[][2])
{
  int i;
  char a, b;

  for(i=0; i<plithos; i++)
    {
      a=input[i][0];
      b=input[i][1];
      output[i][0]=num2accid(a);
      output[i][1]=num2notename(b);
    }

  /* Print results for check */
  /*
  printf("\n");
  for(i=0; i<plithos; i++) printf("%c%c ", output[i][0], output[i][1]);
  printf("\n");
  printf("\n");
  */
}

void make_name(int argc, char **argv, char infilename[])
{
  int i, d, st;
  
  i=0;
  while(argv[argc-1][i]!='.')
    {
      infilename[i]=argv[argc-1][i];
      i++;
    }

  infilename[i]='.';
  infilename[i+1]='t';
  infilename[i+2]='e';
  infilename[i+3]='x';
  infilename[i+4]='\0';

  /* Check results. */
  //printf("%s\n", infilename);
}

/* NAME    : enharmonic
   FUNCTION: it returns the enharmonic note of a given one,
             if the latter has no natural accidental.
   INPUT   : acc1 (accidental if the given note),
             note1 (name of the give note),
   OUTPUT  : acc2 (accidental if the enharmonic note),
             note2 (name of the enharmonic note).
*/

void enharmonic(int acc1, int note1, int *acc2, int *note2)
{
  /* If the accidental is a sharp... */
  if(acc1==1)
    {
      *note2=note1+1;
	/* and the note is neither B nor E: */
	if(note1%7!=6 && note1%7!=2) *acc2=-1;
	else *acc2=0;
    }
  /* If the accidental is a flat... */
  else if(acc1==-1)
    {
      *note2=note1-1;
      /* ...and the note is neither C nor F: */
      if(note1%7!=0 && note1%7!=3) *acc2=+1;
      else *acc2=0;
    }
  /* If the accidental is a natural... */
  else if(acc1==0)
    {
      /* ...and the note is a C or a F: */
      if(note1%7==0 || note1%7==3)
	{
	  *note2=note1+1;
	  *acc2=0;
	}
      /* ...and the note is a B or E: */
      if(note1%7==6 || note1%7)
	{
	  *note2=note1-1;
	  *acc2=0;
	}
    }
}

void make_options(char **argv, int i, int opt[])
{
  if(argv[i][0]=='-')
    {
      if(argv[i][1]=='e') opt[0]=0;
      else if(argv[i][1]=='n') opt[1]=0;
      else if(argv[i][1]=='f')
	{
	  if(argv[i][2]=='1') opt[2]=0;
	  else if(argv[i][2]=='2') opt[3]=0;
	}
    }
}

void init_opt(int opt[])
{
  int i;
  for(i=0; i<4; i++) opt[i]=1;
}
